import img2dataset
import argparse
import os

if __name__ == "__main__":

    parser = argparse.ArgumentParser(description="Download distractors")
    parser.add_argument(
        "--processes_count",
        type=int,
        default=os.cpu_count(),
        help="Number of processes to use for downloading",
    )
    parser.add_argument(
        "--thread_count",
        type=int,
        default=256,
        help="Number of threads to use for downloading",
    )
    parser.add_argument(
        "--timeout",
        type=int,
        default=10,
        help="Timeout in seconds for downloading each image",
    )
    parser.add_argument(
        "--retries",
        type=int,
        default=1,
        help="Number of retries for failed downloads",
    )
    parser.add_argument(
        "--output_folder",
        type=str,
        default="./distractors",
        help="Output folder for downloaded images",
    )
    args = parser.parse_args()

    img2dataset.download(
        "lrvsf-testset/distractors_urls.parquet",
        image_size=256,
        resize_mode="keep_ratio",
        resize_only_if_bigger=False,
        processes_count=args.processes_count,
        thread_count=args.thread_count,
        output_format="parquet",
        input_format="parquet",
        url_col="URL",
        save_additional_columns=["CATEGORY"],
        timeout=args.timeout,
        retries=args.retries,
        number_sample_per_shard=5000,
        output_folder=args.output_folder,
    )
